"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Authentication = function Authentication(Component) {
  var AuthComponent = function (_Component) {
    _inherits(AuthComponent, _Component);

    function AuthComponent(props) {
      _classCallCheck(this, AuthComponent);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(AuthComponent).call(this, props));

      _this.isAuthenticating = false;
      _this.authenticate(_this.props);
      return _this;
    }

    _createClass(AuthComponent, [{
      key: "componentWillMount",
      value: function componentWillMount() {
        if (this.props.isAuthenticated && _get(Object.getPrototypeOf(AuthComponent.prototype), "componentWillMount", this)) {
          _get(Object.getPrototypeOf(AuthComponent.prototype), "componentWillMount", this).call(this);
        }
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        if (this.props.isAuthenticated && _get(Object.getPrototypeOf(AuthComponent.prototype), "componentDidMount", this)) {
          _get(Object.getPrototypeOf(AuthComponent.prototype), "componentDidMount", this).call(this);
        }
      }
    }, {
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        if (!this.authenticate(nextProps)) {
          return;
        }
        var canReplay = this.props.isAuthenticated !== nextProps.isAuthenticated;
        if (canReplay && _get(Object.getPrototypeOf(AuthComponent.prototype), "componentWillMount", this)) {
          _get(Object.getPrototypeOf(AuthComponent.prototype), "componentWillMount", this).call(this);
        }
        if (_get(Object.getPrototypeOf(AuthComponent.prototype), "componentWillReceiveProps", this)) {
          _get(Object.getPrototypeOf(AuthComponent.prototype), "componentWillReceiveProps", this).call(this, nextProps);
        }
        if (canReplay && _get(Object.getPrototypeOf(AuthComponent.prototype), "componentDidMount", this)) {
          _get(Object.getPrototypeOf(AuthComponent.prototype), "componentDidMount", this).call(this);
        }
      }
    }, {
      key: "authenticate",
      value: function authenticate(_ref) {
        var isAuthenticated = _ref.isAuthenticated;
        var goToLogin = _ref.goToLogin;
        var actions = _ref.actions;

        if (isAuthenticated) {
          this.isAuthenticating = false;
          return true;
        }

        //  prevent to call goToLogin multiple times
        if (this.isAuthenticating) {
          return false;
        }
        this.isAuthenticating = true;

        if (goToLogin) {
          goToLogin();
          return false;
        }
        if (actions && actions.goToLogin) {
          actions.goToLogin();
          return false;
        }
        return false;
      }
    }, {
      key: "render",
      value: function render() {
        return this.props.isAuthenticated ? _get(Object.getPrototypeOf(AuthComponent.prototype), "render", this).call(this) : null;
      }
    }]);

    return AuthComponent;
  }(Component);

  return AuthComponent;
};

exports.default = Authentication;